// **********************************************************
// File:	Math3D.cpp - 15/9/2004
// Desc:	file description
//
// Copyright (c) 2004 by robal. All rights reserved.
// **********************************************************

#include "Math3D.h"
#include <math.h>

SVector3f	vect;

SVector3f operator + ( const SVector3f& vect1, const SVector3f& vect2 )
{
	return SVector3f( vect1.x + vect2.x, vect1.y + vect2.y, vect1.z + vect2.z );
}

SVector3f operator - ( const SVector3f& vect1, const SVector3f& vect2 )
{
	return SVector3f( vect1.x - vect2.x,
						vect1.y - vect2.y,
						vect1.z - vect2.z );
}

SVector3f operator * ( const SVector3f& vect1, const SVector3f& vect2 )
{
	return SVector3f( vect1.x * vect2.x,
						vect1.y * vect2.y,
						vect1.z * vect2.z );
}

SVector3f operator * ( const SVector3f& vect1, const float& fValue )
{
	return SVector3f( vect1.x * fValue,
						vect1.y * fValue,
						vect1.z * fValue );
}

SVector3f operator * ( const float& fValue, const SVector3f& vect1 )
{
	return SVector3f( vect1.x * fValue,
						vect1.y * fValue,
						vect1.z * fValue );
}

SVector3f operator / ( const SVector3f& vect1, const SVector3f& vect2 )
{
	return SVector3f( vect1.x / vect2.x,
						vect1.y / vect2.y,
						vect1.z / vect2.z );
}

SVector3f operator / ( const SVector3f& vect1, const float& fValue )
{
	return SVector3f( vect1.x / fValue,
						vect1.y / fValue,
						vect1.z / fValue );
}

// -- vector3f functions --
float Vec3Length( SVector3f& vect )
{
	return sqrtf( vect.x * vect.x + vect.y * vect.y + vect.z * vect.z );
}

SVector3f Vec3Normalize( SVector3f& vect )
{
	float	fLength = Vec3Length( vect );

	vect.x = vect.x / fLength;
	vect.y = vect.y / fLength;
	vect.z = vect.z / fLength;

	return vect;
}

SVector3f Vec3Cross( const SVector3f& vect1, const SVector3f& vect2 )
{
	SVector3f	vectOut;

	vectOut.x = vect1.y * vect2.z - vect1.z * vect2.y;
	vectOut.y = vect1.z * vect2.x - vect1.x * vect2.z;
	vectOut.z = vect1.x * vect2.y - vect1.y * vect2.x;

	return vectOut;
}

float Vec3Dot( const SVector3f& vect1, const SVector3f& vect2 )
{
	return vect1.x * vect2.x + vect1.y * vect2.y + vect1.z * vect2.z;
}

