// **********************************************************
// File:	Math3D.h - 15/9/2004
// Desc:	file description
//
// Copyright (c) 2004 by robal. All rights reserved.
// **********************************************************

#ifndef MATH3D_H
#define MATH3D_H

#include "Structures.h"

// -- vector3f operators --
SVector3f operator + ( const SVector3f&, const SVector3f& );
SVector3f operator - ( const SVector3f&, const SVector3f& );
SVector3f operator * ( const SVector3f&, const SVector3f& );
SVector3f operator * ( const SVector3f&, const float& );
SVector3f operator * ( const float&, const SVector3f& );
SVector3f operator / ( const SVector3f&, const SVector3f& );
SVector3f operator / ( const SVector3f&, const float& );

// -- vector3f functions --
SVector3f Vec3Normalize( SVector3f& );
SVector3f Vec3Cross( const SVector3f&, const SVector3f& );
float Vec3Length( SVector3f& vect );
float Vec3Dot( const SVector3f&, const SVector3f& );


#endif	//MATH3D_H