vs.1.1

 ;―――――――――――――――
 ; Constant registers 
 ;―――――――――――――――
 ;
 ; c0-c3 - world transform matrix
 ; c4-c7 - view*proj transform matrix
 ; c8 - eye position

 ;―――――――――――――――
 ; Input registers
 ;―――――――――――――――
 ;
dcl_position	v0
dcl_normal		v3
dcl_texcoord0	v7
dcl_texcoord1	v8
dcl_texcoord2	v9
dcl_texcoord3	v10

 ;―――――――――――――――
 ; Output
 ;―――――――――――――――
 ;
 ; oT0 - tex coord
 ; oT1 - move u to world space
 ; oT2 - move v to world space
 ; oT3 - move uv to world space
 ; oT1.w, oT2.w, oT3.w - eye vector
 ; oD0 - store diffuse color

 ;===========================================================================
 ; light and helper
def c9, 0.0f, 0.0f,-1.0f, 0.0f
def c10, 0.0f, 0.25f, 0.5f, 1.0f
def c11, 0.5f, 0.5f, 0.5f, 0.5f

 ; transform position into world space
dp4 r0.x, v0, c0
dp4 r0.y, v0, c1
dp4 r0.z, v0, c2
dp4 r0.w, v0, c3

 ; move u to world space
dp3 r2.x, v8, c0
dp3 r2.y, v8, c1
dp3 r2.z, v8, c2

 ; move v to world space
dp3 r3.x, v9, c0
dp3 r3.y, v9, c1
dp3 r3.z, v9, c2

 ; move uv to world space
dp3 r4.x, v10, c0
dp3 r4.y, v10, c1
dp3 r4.z, v10, c2

mov oT1.xyz, r2.xyz
mov oT2.xyz, r3.xyz
mov oT3.xyz, r4.xyz

 ; move light to texture space
dp3 r1.x, r2.xyz, c9
dp3 r1.y, r3.xyz, c9
dp3 r1.z, r4.xyz, c9

 ; store diffuse color
mov oD0, c11

 ; calculate eye vector and put it to texture
sub r1.xyz, r0.xyz, c8.xyz	; from eye to vertex
dp3 r1.w, r1.xyz, r1.xyz	; normalize eye vector
rsq r1.w, r1.w
mul r1.xyz, r1.xyz, r1.w

mov oT1.w, r1.x
mov oT2.w, r1.y
mov oT3.w, r1.z
mov oT0.xy, v7.xy

 ; output
dp4 oPos.x, r0, c4
dp4 oPos.y, r0, c5
dp4 oPos.z, r0, c6
dp4 oPos.w, r0, c7
